/**
 * OpaqueToken is used with provide() to bind a const. It allows the dev
 * to avoid using a string.
 *
 * @example
 *
 ```
 let LIVES = new OpaqueToken('threshold');

 @Component({
   selector: 'player',
   template: `Lives Left: {{player.lives}}`
 })
 @Inject(LIVES)
 class Player {
   constructor(lives) {
     this.lives = lives;
   }
 }

 @Component({
   selector: 'game',
   providers: [provide(LIVES, {useValue: 3})],
   directives: [Player],
   template: `<player></player>`
 })
 class Game {}
 ```
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var OpaqueToken = (function () {
  function OpaqueToken(_desc) {
    _classCallCheck(this, OpaqueToken);

    this._desc = _desc;
  }

  _createClass(OpaqueToken, [{
    key: "toString",
    value: function toString() {
      return "Token " + this._desc;
    }
  }]);

  return OpaqueToken;
})();

exports.OpaqueToken = OpaqueToken;