/*global describe,it */
'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

require('../tests/frameworks');

var _classesOpaqueToken = require('../classes/opaque-token');

var _decoratorsProvidersComponent = require('../decorators/providers/component');

var _decoratorsInject = require('../decorators/inject');

var _classesProvider = require('../classes/provider');

var _testsInternalUtils = require('../tests/internal-utils');

describe("Opaque Token", function () {
  it('creates a simple token object', function () {
    new _classesOpaqueToken.OpaqueToken('foo').toString().should.eql('Token foo');
  });

  it('works using example from docs', function () {
    var LIVES = new _classesOpaqueToken.OpaqueToken('threshold');

    var Player = (function () {
      function Player(lives) {
        _classCallCheck(this, _Player);

        this.lives = lives;
      }

      var _Player = Player;
      Player = (0, _decoratorsInject.Inject)(LIVES)(Player) || Player;
      Player = (0, _decoratorsProvidersComponent.Component)({
        selector: 'player',
        template: '{{player.lives}}'
      })(Player) || Player;
      return Player;
    })();

    var Game = (function () {
      function Game() {
        _classCallCheck(this, _Game);
      }

      var _Game = Game;
      Game = (0, _decoratorsProvidersComponent.Component)({
        selector: 'game',
        providers: [(0, _classesProvider.provide)(LIVES, { useValue: 3 })],
        directives: [Player],
        template: '<player></player>'
      })(Game) || Game;
      return Game;
    })();

    var root = (0, _testsInternalUtils.quickRootTestComponent)({ directives: [Game], template: '<game></game>' });
    root.debugElement.text().should.equal('3');
  });
});