/*global describe, it, beforeEach */
'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

require('../../tests/frameworks');

var _testsAngular = require('../../tests/angular');

var _writers = require('../../writers');

var _module2 = require('../../module');

var _module3 = _interopRequireDefault(_module2);

var _pipe = require('./pipe');

describe('@Pipe Decorator', function () {
	beforeEach(function () {
		return _pipe.Pipe.clearNameCache();
	});

	it('should set the correct name and provider type', function () {
		var SplicePipe = (function () {
			function SplicePipe() {
				_classCallCheck(this, _SplicePipe);
			}

			var _SplicePipe = SplicePipe;
			SplicePipe = (0, _pipe.Pipe)('splice')(SplicePipe) || SplicePipe;
			return SplicePipe;
		})();

		_writers.providerWriter.get('type', SplicePipe).should.eql('pipe');
		_writers.providerWriter.get('name', SplicePipe).should.eql('splice');
	});

	it('should be parsed into a pipe', function () {
		var SplicePipe = (function () {
			function SplicePipe() {
				_classCallCheck(this, _SplicePipe2);
			}

			var _SplicePipe2 = SplicePipe;
			SplicePipe = (0, _pipe.Pipe)('splice')(SplicePipe) || SplicePipe;
			return SplicePipe;
		})();

		(0, _module3['default'])('test', []).add(SplicePipe);

		_testsAngular.ngMocks.filter.should.have.been.calledWith('splice');
	});

	describe('Pipe Parser Implementation', function () {
		var pipe = undefined;

		beforeEach(function () {
			var parser = _module3['default'].getParser('pipe');

			var Test = (function () {
				function Test() {
					_classCallCheck(this, Test);
				}

				_createClass(Test, [{
					key: 'supports',
					value: function supports(input) {
						return typeof input === 'string';
					}
				}, {
					key: 'transform',
					value: function transform(input, param) {
						return input + '-' + param;
					}
				}]);

				return Test;
			})();

			parser(Test, 'test', [], {
				filter: function filter(name, pipeBlock) {
					pipe = pipeBlock[0]();
				}
			});
		});

		it('should have created a pipe', function () {
			pipe.should.be.defined;
		});

		it('should check for support before applying the transform', function () {
			var test = function test(obj) {
				return pipe(obj);
			};

			test.should['throw'](Error, /does not support/);
		});

		it('should apply the transform if the test passes', function () {
			pipe('hello', 'world').should.eql('hello-world');
		});
	});
});