// # @StateComponent
// A routeable component designed for ui-router

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _writers = require('../../writers');

var _Providers = require('../Providers');

var _module2 = require('../../module');

var _module3 = _interopRequireDefault(_module2);

var StateComponent = function StateComponent(name) {
  var config = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  return function (t) {
    var controllerAs = name.split(/(\ |\-|\_|\.)/g).map(function (part, index) {
      if (index === 0) {
        return part.toLowerCase();
      } else {
        return '' + part[0].toUpperCase() + part.slice(1).toLowerCase();
      }
    }).join('');

    _writers.componentWriter.set('controllerAs', controllerAs, t);

    for (var key in config) {
      _writers.componentWriter.set(key, config[key], t);
    }

    if (_writers.componentWriter.has('children', t)) {
      var children = _writers.componentWriter.get('children', t);
      _Providers.Providers.apply(undefined, _toConsumableArray(children))(t);
      _writers.componentWriter['delete']('children', t);
    }

    if (_writers.componentWriter.has('bindings', t)) {
      var bindings = _writers.componentWriter.get('bindings', t);
      _Providers.Providers.apply(undefined, _toConsumableArray(bindings))(t);
      _writers.componentWriter['delete']('bindings', t);
    }

    _writers.providerWriter.set('name', name, t);
    _writers.providerWriter.set('type', 'state-component', t);
  };
};

exports.StateComponent = StateComponent;
_module3['default'].addProvider('state-component', function (provider, name, injects, ngModule) {
  ngModule.config(['$stateProvider', '$locationProvider', function ($stateProvider, $locationProvider) {
    $locationProvider.html5Mode({ enabled: true, requireBase: false });
    $locationProvider.hashPrefix('!');
    var config = {};

    _writers.componentWriter.forEach(function (val, key) {
      return config[key] = val;
    }, provider);

    config.controller = [].concat(_toConsumableArray(injects), [provider]);

    $stateProvider.state(name, config);
  }]);
});