'use strict';

var _testsFrameworks = require('../tests/frameworks');

var _annotate = require('./annotate');

describe('Decorator helpers for ES5/ES6', function () {
  it('should export the d helper object and two registeration functions', function () {
    _annotate.a.should.be.defined;
    _annotate.register.should.be.defined;
    _annotate.registerFactory.should.be.defined;
  });

  it('should let you register new simple decorators', function () {
    var spy = _testsFrameworks.sinon.spy();
    (0, _annotate.register)('Test', spy);
    _annotate.a.Test['for'](function () {});

    _annotate.a.Test.should.be.defined;
    spy.should.have.been.called;
  });

  it('should let you register new decorator factories', function () {
    var spy = _testsFrameworks.sinon.spy();
    (0, _annotate.registerFactory)('NewTest', function () {
      return spy;
    });
    _annotate.a.NewTest()['for'](function () {});

    _annotate.a.NewTest.should.be.defined;
    spy.should.have.been.called;
  });
});