/* global describe, it */
'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _testsFrameworks = require('../tests/frameworks');

var _utilEvents = require('../util/events');

var _utilEvents2 = _interopRequireDefault(_utilEvents);

var _testsInternalUtils = require('../tests/internal-utils');

describe('Auto-generated Event Directives', function () {
  var _this = this;

  describe('Angular Integration', function () {

    beforeEach(function () {
      _this.clock = _testsFrameworks.sinon.useFakeTimers();
    });

    afterEach(function () {
      _this.clock.restore();
    });

    it('creates a directive per item in the set', function () {
      var root = (0, _testsInternalUtils.quickRootTestComponent)({});

      var allEvents = ['click', 'dblclick', 'mousedown', 'mouseup', 'mouseover', 'mouseout', 'mousemove', 'mouseenter', 'mouseleave', 'keydown', 'keyup', 'keypress', 'submit', 'focus', 'blur', 'copy', 'cut', 'paste', 'change', 'dragstart', 'drag', 'dragenter', 'dragleave', 'dragover', 'drop', 'dragend', 'error', 'input', 'load', 'wheel', 'scroll'];

      var asserts = 0;

      allEvents.forEach(function (name) {
        asserts++;
        root.debugElement.getLocal('(' + name + ')Directive')[0].name.should.eql('(' + name + ')');
      });

      asserts.should.eql(allEvents.length);
    });

    it('bubbles the events', function () {
      var root = (0, _testsInternalUtils.quickRootTestComponent)({
        template: '\n        <div ng-init="test.clicked=false" (click)="test.clicked=true">\n          <button>Click Me</button>\n        </div>\n        '
      });

      root.debugElement.componentInstance.clicked.should.be['false'];
      root.debugElement.find('button').nativeElement.click();
      root.debugElement.componentInstance.clicked.should.be['true'];
    });
  });
});