/* global describe, it */
'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _getInjectableName = require('./get-injectable-name');

var _writers = require('../writers');

require('../tests/frameworks');

describe('getInjectableName', function () {
  it('returns an input string', function () {
    (0, _getInjectableName.getInjectableName)('foo').should.eql('foo');
  });

  it('returns the provider metadata name if there is one', function () {
    var Foo = function Foo() {
      _classCallCheck(this, Foo);
    };

    _writers.providerWriter.set('type', 'foo', Foo);
    _writers.providerWriter.set('name', 'foo', Foo);
    (0, _getInjectableName.getInjectableName)(Foo).should.contain('foo');
  });
});

describe('getInjectableNameWithJitCreation', function () {
  it('returns an input string', function () {
    (0, _getInjectableName.getInjectableNameWithJitCreation)('foo').should.eql('foo');
  });

  it('returns the provider metadata name if there is one', function () {
    var Foo = function Foo() {
      _classCallCheck(this, Foo);
    };

    _writers.providerWriter.set('type', 'foo', Foo);
    _writers.providerWriter.set('name', 'foo', Foo);
    (0, _getInjectableName.getInjectableNameWithJitCreation)(Foo).should.contain('foo');
  });

  it('registers normal classes as a Injectable and then returns their name', function () {
    var Foo = function Foo() {
      _classCallCheck(this, Foo);
    };

    (0, _getInjectableName.getInjectableNameWithJitCreation)(Foo).should.contain('Foo');
  });
});