'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = groupModulesAndProviders;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _writers = require('../writers');

var _flattenArray = require('./flatten-array');

var _flattenArray2 = _interopRequireDefault(_flattenArray);

var _classesProvider = require('./../classes/provider');

var STRING_TEST = function STRING_TEST(a) {
  return typeof a === 'string';
};
var PROVIDER_TEST = function PROVIDER_TEST(a) {
  return (typeof a === 'function' || a instanceof _classesProvider.Provider) && _writers.providerWriter.has('name', a);
};

function groupModulesAndProviders(modulesAndProviders) {
  modulesAndProviders = (0, _flattenArray2['default'])(modulesAndProviders);

  // find all modules
  var modules = modulesAndProviders.filter(STRING_TEST);
  // find all annotated classes and Providers
  var providers = modulesAndProviders.filter(PROVIDER_TEST);

  if (modulesAndProviders.length !== modules.length + providers.length) {
    throw new Error('One or more of your providers was not valid. Please make sure all providers are either: ' + 'a class, decorated class, Provider instance, or module string');
  }

  return { modules: modules, providers: providers };
}

module.exports = exports['default'];