'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

var _helpers = require('./helpers');

var _getInjectableName = require('./get-injectable-name');

Object.defineProperties(angular.element.prototype, {

  nativeElement: {
    get: function get() {
      return this[0];
    }
  },

  componentInstance: {
    get: function get() {
      if (this._componentInstance) return this._componentInstance;
      var isolateScope = this.isolateScope();
      var name = (0, _helpers.dashToCamel)(this[0].tagName.toLowerCase());
      this._componentInstance = isolateScope && isolateScope[name] || null;
      return this._componentInstance;
    }
  },

  componentViewChildren: {
    get: function get() {
      return [].concat(_toConsumableArray(this.children())).map(function (child) {
        return angular.element(child);
      });
    }
  },

  getLocal: {
    value: function value(injectable) {
      return (this.injector() || this.inheritedData('$injector')).get((0, _getInjectableName.getInjectableName)(injectable));
    }
  }

});

exports['default'] = angular.element;
module.exports = exports['default'];